import depthai
from typing import ClassVar

class XLinkIn(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.XLinkInProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getMaxDataSize(self) -> int:
        """getMaxDataSize(self: depthai.node.internal.XLinkIn) -> int

        Get maximum messages size in bytes
        """
    def getNumFrames(self) -> int:
        """getNumFrames(self: depthai.node.internal.XLinkIn) -> int

        Get number of frames in pool
        """
    def getStreamName(self) -> str:
        """getStreamName(self: depthai.node.internal.XLinkIn) -> str

        Get stream name
        """
    def setMaxDataSize(self, maxDataSize: int) -> None:
        """setMaxDataSize(self: depthai.node.internal.XLinkIn, maxDataSize: int) -> None

        Set maximum message size it can receive

        Parameter ``maxDataSize``:
            Maximum size in bytes
        """
    def setNumFrames(self, numFrames: int) -> None:
        """setNumFrames(self: depthai.node.internal.XLinkIn, numFrames: int) -> None

        Set number of frames in pool for sending messages forward

        Parameter ``numFrames``:
            Maximum number of frames in pool
        """
    def setStreamName(self, streamName: str) -> None:
        """setStreamName(self: depthai.node.internal.XLinkIn, streamName: str) -> None

        Specifies XLink stream name to use.

        The name should not start with double underscores '__', as those are reserved
        for internal use.

        Parameter ``name``:
            Stream name
        """
    @property
    def out(self) -> depthai.Node.Output: ...

class XLinkOut(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.XLinkOutProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getFpsLimit(self) -> float:
        """getFpsLimit(self: depthai.node.internal.XLinkOut) -> float

        Get rate limit in messages per second
        """
    def getMetadataOnly(self) -> bool:
        """getMetadataOnly(self: depthai.node.internal.XLinkOut) -> bool

        Get whether to transfer only messages attributes and not buffer data
        """
    def getStreamName(self) -> str:
        """getStreamName(self: depthai.node.internal.XLinkOut) -> str

        Get stream name
        """
    def setFpsLimit(self, fpsLimit: float) -> None:
        """setFpsLimit(self: depthai.node.internal.XLinkOut, fpsLimit: float) -> None

        Specifies a message sending limit. It's approximated from specified rate.

        Parameter ``fps``:
            Approximate rate limit in messages per second
        """
    def setMetadataOnly(self, arg0: bool) -> None:
        """setMetadataOnly(self: depthai.node.internal.XLinkOut, arg0: bool) -> None

        Specify whether to transfer only messages attributes and not buffer data
        """
    def setStreamName(self, streamName: str) -> None:
        """setStreamName(self: depthai.node.internal.XLinkOut, streamName: str) -> None

        Specifies XLink stream name to use.

        The name should not start with double underscores '__', as those are reserved
        for internal use.

        Parameter ``name``:
            Stream name
        """
    @property
    def input(self) -> depthai.Node.Input: ...
